package PRFramework.Core.SupervisedClassifiers.DecisionTrees.DistributionEvaluators;


import weka.core.Option;

import java.io.Serializable;
import java.util.Arrays;
import java.util.Enumeration;

public class Twoing implements IDistributionEvaluator, Serializable
        {
public double Evaluate(double[] parent, double[][] children)
        {
        // preconditions
        if (children.length != 2)
            throw new IllegalArgumentException("Twoing Distance need only two child nodes (binary split)");

        double parent_sum = Arrays.stream(parent).sum();
        if (parent_sum == Arrays.stream(parent).max().getAsDouble())
        return 0;


        double total = parent_sum;
        //0.25*pl*pr
        double SL = Arrays.stream(children[0]).sum();
        double SR = Arrays.stream(children[1]).sum();
        double twoing = 0.25* SL/total * SR/total;

        double aux = 0;
        for (int i = 0; i < parent.length; i++)
        {
        aux += Math.abs((children[0][i] / SL) - (children[1][i] / SR));
        }
        twoing *= Math.pow(aux, 2.0);
        return twoing;
        }

            @Override
            public Enumeration<Option> listOptions() {
                return null;
            }

            @Override
            public void setOptions(String[] strings) throws Exception {

            }

            @Override
            public String[] getOptions() {
                return new String[0];
            }
        }
