package PRFramework.Core.SupervisedClassifiers.EmergingPatterns.Qualities.Statistical;

import PRFramework.Core.Common.PrDescriptionAttribute;
import PRFramework.Core.SupervisedClassifiers.EmergingPatterns.Qualities.ContingenceTable;
import PRFramework.Core.SupervisedClassifiers.EmergingPatterns.Qualities.ContingenceTableBasedQuality;
import java.io.Serializable;

/**
 * Casual confidence Y. Kodratoff, Comparing machine learning and knowledge
 * discovery in databases: An application to knowledge discovery in texts, in:
 * G. Paliouras, V. Karkaletsis, C. D. Spyropoulos (Eds.), Machine Learning and
 * Its Applications, Vol. 2049 of Lecture Notes in Computer Science, Springer
 * Berlin Heidelberg, 2001, pp. 1–21.
 */
@PrDescriptionAttribute("CslConf")
public class CausalConfidenceQuality extends ContingenceTableBasedQuality implements Serializable
{

    @Override
    public double GetQuality (ContingenceTable t)
    {
        double value = 1 - 0.5 * (t.getf_P_nC() / t.getf_P() + t.getf_P_nC() / t.getf_nC());
        return super.ValidateResult(value);
    }
}
